Asterisk.org: Developer Documentation (28 Oct 2009)

Wed Oct 28 15:49:33 2009

## Asterisk developer's documentation

# call_queue Struct Reference

Collaboration diagram for call_queue:

[legend]

## Data Fields

char | announce [80]
int | announcefrequency
unsigned int | announceholdtime:2
int | callsabandoned
int | callscompleted
int | callscompletedinsl
char | context [AST_MAX_CONTEXT]
int | count
unsigned int | dead:1
unsigned int | eventwhencalled:1
struct queue_ent * | head
int | holdtime
unsigned int | joinempty:2
unsigned int | leavewhenempty:2
ast_mutex_t | lock
unsigned int | maskmemberstatus:1
int | maxlen
int | memberdelay
struct member * | members
char | moh [80]
char | monfmt [8]
unsigned int | monjoin:1
char | name [80]
struct call_queue * | next
int | periodicannouncefrequency
unsigned int | realtime:1
unsigned int | reportholdtime:1
int | retry
int | roundingseconds
int | rrpos
int | servicelevel
char | sound_calls [80]
char | sound_holdtime [80]
char | sound_lessthan [80]
char | sound_minutes [80]
char | sound_next [80]
char | sound_periodicannounce [80]
char | sound_reporthold [80]
char | sound_seconds [80]
char | sound_thanks [80]
char | sound_thereare [80]
unsigned int | strategy:3
int | timeout
unsigned int | timeoutrestart:1
int | weight
unsigned int | wrapped:1
int | wrapuptime

## Detailed Description

Definition at line 319 of file app_queue.c.

## Field Documentation

char announce[80]

Announcement to play when call is answered

Definition at line 323 of file app_queue.c.

Referenced by init_queue(), join_queue(), and queue_set_param().

int announcefrequency

How often to announce their position

Definition at line 337 of file app_queue.c.

Referenced by init_queue(), queue_exec(), queue_set_param(), say_position(), and wait_our_turn().

unsigned int announceholdtime

Definition at line 333 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and say_position().

int callsabandoned

Number of queue calls abandoned

Definition at line 342 of file app_queue.c.

Referenced by __queues_show(), clear_queue(), manager_queues_status(), and record_abandoned().

int callscompleted

Number of queue calls completed

Definition at line 341 of file app_queue.c.

Referenced by __queues_show(), clear_queue(), manager_queues_status(), and update_queue().

int callscompletedinsl

Number of calls answered with servicelevel

Definition at line 344 of file app_queue.c.

Referenced by __queues_show(), clear_queue(), manager_queues_status(), and update_queue().

char context[AST_MAX_CONTEXT]

Exit context

Definition at line 324 of file app_queue.c.

Referenced by init_queue(), join_queue(), and queue_set_param().

int count

How many entries

Definition at line 357 of file app_queue.c.

Referenced by __queues_show(), compare_weight(), find_queue_by_name_rt(), join_queue(), leave_queue(), manager_queues_status(), and reload_queues().

unsigned int dead

Definition at line 326 of file app_queue.c.

Referenced by find_queue_by_name_rt(), init_queue(), leave_queue(), and reload_queues().

unsigned int eventwhencalled

Definition at line 328 of file app_queue.c.

Referenced by queue_set_param(), ring_entry(), and try_calling().

struct queue_ent* head`[read]`

Head of the list of callers

Definition at line 370 of file app_queue.c.

Referenced by __queues_show(), insert_entry(), is_our_turn(), join_queue(), leave_queue(), and manager_queues_status().

int holdtime

Current avg holdtime, based on recursive boxcar filter

Definition at line 340 of file app_queue.c.

Referenced by __queues_show(), clear_queue(), manager_queues_status(), recalc_holdtime(), and say_position().

unsigned int joinempty

Definition at line 327 of file app_queue.c.

Referenced by join_queue(), and queue_set_param().

unsigned int leavewhenempty

Definition at line 329 of file app_queue.c.

Referenced by queue_exec(), queue_set_param(), and wait_our_turn().

ast_mutex_t lock

Definition at line 320 of file app_queue.c.

Referenced by __queues_show(), add_to_queue(), alloc_queue(), changethread(), compare_weight(), complete_remove_queue_member(), destroy_queue(), find_queue_by_name_rt(), get_member_status(), interface_exists_global(), join_queue(), leave_queue(), manager_queues_status(), queue_function_qac(), recalc_holdtime(), record_abandoned(), reload_queue_members(), reload_queues(), remove_from_queue(), ring_entry(), set_member_paused(), try_calling(), update_queue(), and update_status().

unsigned int maskmemberstatus

Definition at line 335 of file app_queue.c.

Referenced by changethread(), queue_set_param(), and update_status().

int maxlen

Max number of entries

Definition at line 358 of file app_queue.c.

Referenced by __queues_show(), init_queue(), join_queue(), manager_queues_status(), and queue_set_param().

int memberdelay

Seconds to delay connecting member to caller

Definition at line 367 of file app_queue.c.

Referenced by queue_set_param(), and try_calling().

struct member* members`[read]`

Head of the list of members

Definition at line 369 of file app_queue.c.

Referenced by __queues_show(), add_to_queue(), changethread(), compare_weight(), complete_remove_queue_member(), dump_queue_members(), find_queue_by_name_rt(), free_members(), get_member_status(), interface_exists(), interface_exists_global(), manager_queues_status(), queue_function_qac(), reload_queues(), remove_from_queue(), rt_handle_member_record(), try_calling(), update_queue(), and update_status().

char moh[80]

Music On Hold class to be used

Definition at line 322 of file app_queue.c.

Referenced by init_queue(), join_queue(), and queue_set_param().

char monfmt[8]

Format to use when recording calls

Definition at line 345 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and try_calling().

unsigned int monjoin

Definition at line 325 of file app_queue.c.

Referenced by queue_set_param(), and try_calling().

char name[80]

Name

Definition at line 321 of file app_queue.c.

Referenced by __queues_show(), add_to_queue(), alloc_queue(), changethread(), compare_weight(), complete_queue(), dump_queue_members(), find_queue_by_name_rt(), join_queue(), leave_queue(), load_realtime_queue(), manager_queues_status(), queue_function_qac(), queue_set_param(), reload_queue_members(), reload_queues(), remove_from_queue(), ring_entry(), say_position(), set_member_paused(), try_calling(), update_status(), wait_for_answer(), and wait_our_turn().

struct call_queue* next`[read]`

Next call queue

Definition at line 371 of file app_queue.c.

Referenced by __queues_show(), changethread(), compare_weight(), complete_queue(), complete_remove_queue_member(), find_queue_by_name_rt(), interface_exists_global(), load_realtime_queue(), manager_queues_status(), queue_function_qac(), reload_queue_members(), reload_queues(), remove_from_queue(), remove_queue(), and set_member_paused().

int periodicannouncefrequency

How often to play periodic announcement

Definition at line 338 of file app_queue.c.

Referenced by init_queue(), queue_exec(), queue_set_param(), say_periodic_announcement(), and wait_our_turn().

unsigned int realtime

Definition at line 336 of file app_queue.c.

Referenced by find_queue_by_name_rt(), and load_realtime_queue().

unsigned int reportholdtime

Definition at line 330 of file app_queue.c.

Referenced by queue_set_param(), and try_calling().

int retry

Retry calling everyone after this amount of time

Definition at line 361 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and wait_a_bit().

int roundingseconds

How many seconds do we round to?

Definition at line 339 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and say_position().

int rrpos

Round Robin - position

Definition at line 366 of file app_queue.c.

Referenced by calc_metric(), ring_entry(), and store_next().

int servicelevel

seconds setting for servicelevel

Definition at line 343 of file app_queue.c.

Referenced by __queues_show(), init_queue(), manager_queues_status(), queue_set_param(), and try_calling().

char sound_calls[80]

Sound file: "calls waiting to speak to a representative." (def. queue-callswaiting)

Definition at line 348 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and say_position().

char sound_holdtime[80]

Sound file: "The current estimated total holdtime is" (def. queue-holdtime)

Definition at line 349 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and say_position().

char sound_lessthan[80]

Sound file: "less-than" (def. queue-lessthan)

Definition at line 351 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), say_position(), and try_calling().

char sound_minutes[80]

Sound file: "minutes." (def. queue-minutes)

Definition at line 350 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), say_position(), and try_calling().

char sound_next[80]

Sound file: "Your call is now first in line" (def. queue-youarenext)

Definition at line 346 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and say_position().

char sound_periodicannounce[80]

Sound file: Custom announce, no default

Definition at line 355 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and say_periodic_announcement().

char sound_reporthold[80]

Sound file: "Hold time" (def. queue-reporthold)

Definition at line 354 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and try_calling().

char sound_seconds[80]

Sound file: "seconds." (def. queue-seconds)

Definition at line 352 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and say_position().

char sound_thanks[80]

Sound file: "Thank you for your patience." (def. queue-thankyou)

Definition at line 353 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and say_position().

char sound_thereare[80]

Sound file: "There are currently" (def. queue-thereare)

Definition at line 347 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and say_position().

unsigned int strategy

Definition at line 334 of file app_queue.c.

Referenced by __queues_show(), calc_metric(), queue_set_param(), ring_one(), try_calling(), and wait_for_answer().

int timeout

How long to wait for an answer

Definition at line 362 of file app_queue.c.

Referenced by init_queue(), queue_set_param(), and try_calling().

unsigned int timeoutrestart

Definition at line 332 of file app_queue.c.

Referenced by queue_set_param(), and wait_for_answer().

int weight

Respective weight

Definition at line 363 of file app_queue.c.

Referenced by __queues_show(), compare_weight(), manager_queues_status(), and queue_set_param().

unsigned int wrapped

Definition at line 331 of file app_queue.c.

Referenced by calc_metric(), and store_next().

int wrapuptime

Wrapup Time

Definition at line 359 of file app_queue.c.

Referenced by clear_queue(), queue_set_param(), and ring_entry().

The documentation for this struct was generated from the following file:

- app_queue.c